clear
nb = 32;    %[%24 %32 %37 %38 %39 %53]
adj = 0;
area_num_2 = 100;

lat_wind = readmatrix('lat_wind.csv');
lon_wind = readmatrix('lon_wind.csv');

TT = readmatrix('Index_list.csv');
T_T = TT;

TTT = readcell('Index_list.csv');
TTTT = TTT(2:end,2:end);
TTTTT = TTTT;

lat_position = find(lat_wind >= T_T(nb,3)-min(abs(lat_wind-T_T(nb,3))) & lat_wind <= T_T(nb,3)+min(abs(lat_wind-T_T(nb,3))))
lon_position = find(lon_wind >= T_T(nb,4)-min(abs(lon_wind-T_T(nb,4))) & lon_wind <= T_T(nb,4)+min(abs(lon_wind-T_T(nb,4))))
T_time = TTTTT(nb,1);
T_time = [T_time{:}];
y = year(T_time);
m = month(T_time);
d = day(T_time);
h = hour(T_time)+1+adj;
h3 = hour(T_time)+adj;
f = minute(T_time);
if h <= 23 
    if f >= 30
        h = h+1;
    end
else
        d = d+1;
        h = 0;
end

time_h = rem(h,6);
time_hh = (h-time_h)/6+1;
time_e = ["0000" "0600" "1200" "1800"];
h2 = time_e(time_hh);

y = num2str(y,'%04d');
m = num2str(m,'%02d');
d = num2str(d,'%02d');
h = num2str(h2,'%04d');
h3 = num2str(h3,'%02d');

T = time_h;    
T_NUM = num2str(T,'%02d');

%% Reading the data directly

% the Hobart airport (lat -42.83 / lon 147.50) --> (lat,lon)--> (236,372)
year = y;   
month = m ;
day = d ; 
time = h ;     % '0000'; '0600'; '1200'; '1800';
variable = 'vertical_wnd';    %'vertical_wnd'; 'wnd_ucmp'; 'wnd_vcmp'; 'air_temp'; 'relhum'; 'pressure'; 'geop_ht'; 'time'; 
region ='BARRA_TA' ;    % 'BARRA_TA';     'BARRA_R';
station = 'prs' ;      
%lat_p =  236   ;         % 1-508 
%lon_p =  372   ;         % 1-594
lat_p =  lat_position ;         % 1-508
lon_p =  lon_position ;         % 1-594
T = time_h; 
area_num = 5;
filePath_max_wndgust10m = ['/Volumes/Backup_Plus/BARRA_TA/','max_wndgust10m/',year,'/',month,'/','max_wndgust10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
time_c= ncread(filePath_max_wndgust10m,'time'); 
max_wndgust10m = ncread(filePath_max_wndgust10m,'max_wndgust10m');
max_wndgust10m = permute(max_wndgust10m,[2 1 3]);

%filePath_wnd_ucmp = ['/Volumes/Backup_Plus/',region,'/','wnd_ucmp/',year,'/',month,'/','wnd_ucmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
%filePath_wnd_vcmp = ['/Volumes/Backup_Plus/',region,'/','wnd_vcmp/',year,'/',month,'/','wnd_vcmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
%U_wind = ncread (filePath_wnd_ucmp,'wnd_ucmp');
%V_wind = ncread (filePath_wnd_vcmp,'wnd_vcmp');
%U = permute(U_wind,[2 1 3 4]);
%V = permute(V_wind,[2 1 3 4]);

%%
T_NUM_1 = '01_11';
name_S = ['DCAPE_S',y,m,d,h3,T_NUM_1,'.csv'];
%name_S = ['DCAPE_S',y,m,d,h3,T_NUM,'.csv'];
name_L = ['DCAPE_L',y,m,d,h3,T_NUM,'.csv'];
DCAPE_num_S = readmatrix(name_S);
DCAPE_num_L = readmatrix(name_L);

%PLOT THE SMALL DCAPE

addpath('/Users/Mac/Documents/m_map')
range_lat = (lat_p-area_num:lat_p+area_num);
range_lon = (lon_p-area_num:lon_p+area_num);
clon1 = [lon_wind(lon_p-area_num) lon_wind(lon_p+area_num)];
clat1 = [lat_wind(lat_p-area_num) lat_wind(lat_p+area_num)];

format short g
time_c = double(time_c);
time = zeros(6,1);

figure(1); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

for time_8 = 1:6
    subplot(2,3,time_8);
       m_contourf(lon_wind(range_lon),lat_wind(range_lat),DCAPE_num_S(:,(time_8-1)*11+1:time_8*11))
       caxis([200 1400])
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       time(time_8) = vpa(time_c(time_8)/24,8);
       transfer_time = datetime(time(time_8) + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       
       titlelin2=['  DCAPE=',num2str(DCAPE_num_S(area_num+1,area_num+1+(time_8-1)*11)),'  maxwndgust10m =',num2str(max_wndgust10m(lat_position,lon_position,time_8))];
       title_name = ['Downdraft CAPE at Tasmaina ',transfer_time_1];
       title([ title_name '\rm' char(10) titlelin2]);  

end

%%
%PLOT THE middle DCAPE

area_num = area_num_2;

addpath('/Users/Mac/Documents/m_map')
range_lat = (lat_p-area_num:lat_p+area_num);
range_lon = (lon_p-area_num:lon_p+area_num);
clon1 = [lon_wind(lon_p-area_num) lon_wind(lon_p+area_num)];
clat1 = [lat_wind(lat_p-area_num) lat_wind(lat_p+area_num)];

format short g
time_c = double(time_c);
time = zeros(6,1);

figure(2); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

       m_contourf(lon_wind(range_lon),lat_wind(range_lat),DCAPE_num_L(range_lat,range_lon))
       caxis([200 1400])
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       shading interp;
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       time(T) = vpa(time_c(T)/24,8);
       transfer_time = datetime(time(T) + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       
       titlelin2=['  DCAPE=',num2str(DCAPE_num_L(lat_p,lon_p)),'  maxwndgust10m =',num2str(max_wndgust10m(lat_position,lon_position,T))];
       title_name = ['Downdraft CAPE at Tasmaina ',transfer_time_1];
       title([ title_name '\rm' char(10) titlelin2]);  
       text(min(xlim),max(ylim),' a)','fontweight','bold','verticalalignment','top','fontsize',20);

time_8 = T;
figure(3); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       %m_contourf(lon_wind,lat_wind,wind_10m(:,:,time_8));
       m_pcolor(lon_wind(range_lon),lat_wind(range_lat),max_wndgust10m(range_lat,range_lon,T));
       caxis([0 30])
       %shading interp; 
       colorbar;
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       %m_quiver(X1(lat_p,lon_p,21),Y1(lat_p,lon_p,21),uwnd10m(lat_p,lon_p,T),vwnd10m(lat_p,lon_p,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['max wind gust 10m above the ground at Tasmaina ',transfer_time_1];
       title(title_name);
       text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
       ax = gca;
       ax.FontSize = 10;
       
       colormap(flipud(m_colmap('Blue',56)))
       
       %figure(6);
       %clf
       %windbarbm(range_lat,range_lon,U(range_lat,range_lon,end,T),V(range_lat,range_lon,end,T),0.9)
       
%% Plotting the DCAPE MAP & WIND_10

addpath('/Users/Mac/Documents/m_map')
clon = [lon_wind(1) lon_wind(end)];
clat = [lat_wind(1) lat_wind(end)];

figure(4); 
clf

m_proj('lambert','lon',clon,'lat',clat);
%m_proj('oblique','lat',clat,'lon',clon,'aspect',.8);
%m_proj('equidistant','lon',clon,'lat',clat); 

time_8 = T;
   subplot(1,2,1);
       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       m_contourf(lon_wind,lat_wind,DCAPE_num_L(:,:));
       caxis([200 1400])
       %shading interp; 
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       %m_quiver(X1(:,:,21),Y1(:,:,21),uwnd10m(:,:,T),vwnd10m(1:end-1,:,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['Downdraft CAPE at Tasmaina ',transfer_time_1];
       title(title_name);
       ax = gca;
       ax.FontSize = 15;
       
   subplot(1,2,2);
       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       %m_contourf(lon_wind,lat_wind,wind_10m(:,:,time_8));
       m_pcolor(lon_wind,lat_wind,max_wndgust10m(:,:,T));
       caxis([0 35])
       %shading interp; 
       colorbar;
      
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       %m_quiver(X1(lat_p,lon_p,21),Y1(lat_p,lon_p,21),uwnd10m(lat_p,lon_p,T),vwnd10m(lat_p,lon_p,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['max wind gust 10m above the ground at Tasmaina ',transfer_time_1];
       title(title_name);
       ax = gca;
       ax.FontSize = 15;

%%
%clearvars
%clearvars -except DCAPE_num