function Plot_skewT_more(wind_u,wind_v,pz,tz,rhz,hz,tt,mpp)

% wind_u = U(lon_p,lat_p,:,T);wind_v = V(lon_p,lat_p,:,T);
% Plot_skewT_more(wind_u,wind_v,pz,tz,rhz,hz,tt);

Tsonde = tz;
Psonde = pz;

ez=6.112.*exp(17.67.*tz./(243.5+tz));   %ez1 = 6.112*exp(17.67*sfc_temp/(243.5+sfc_temp));
qz=rhz.*0.622.*ez./(pz-ez);             %qz1 = spec_hum*0.622*ez1/(sfc_pres-ez1);
chi=log(pz.*qz./(6.112.*(0.622+qz)));   %chi1=log(sfc_pres*qz1/(6.112*(0.622+qz1)));
tdz=243.5.*chi./(17.67-chi);            %sfc_tdz=243.5*chi1/(17.67-chi1);
Tdsonde = tdz;

%-------start function here-----------

%set up the figure

%figure
set(gca,'yscale','log','ydir','reverse')
hold on
set(gca,'fontweight','bold')
set(gca,'ytick',100:100:1000)
%set(gca,'xgrid','on')
%set(gca,'ygrid','on')
axis([-48 56 100 1050]);
W=[0.0001,0.000138,0.00017,0.00021,0.00031,0.00046,0.0007,0.0009,0.00119,...
    0.00165,0.00225,0.00355,0.00475,0.00676,0.01,0.1455,0.0204,0.05];
s=1;

%plot the background: adiabats, temperature lines, w-lines.
for T=-100:5:200  %background T
    [T_dry,~,WinT] = lift_parcel(T,NaN,1000,'dry',W(s)); %find dry adiabat
    [T_moist,p,~] = lift_parcel(T,NaN,1000,'moist',W(s)); %find moist adiabat
    T_moist_skew=T_moist-(30.*log(0.001.*p)); %skew the moist adiabat
    T_dry_skew=T_dry-(30.*log(0.001.*p));   %skew the dry adiabat
    
    T_skew=T-(30.*log(0.001.*p));  % skew the T
    T_moist_skew(T_moist_skew>50)=NaN; 
    T_dry_skew(T_dry_skew>50)=NaN; 
    T_skew(T_skew<-50)=NaN; 
    T_moist_skew(T_moist_skew<-50)=NaN; 
    T_dry_skew(T_dry_skew<-50)=NaN; 
    T_skew(T_skew>50)=NaN;
    WinT(WinT<-50)=NaN; 
    WinT(WinT>50)=NaN;
    plot(T_moist_skew(1:56:end),p(1:56:end),'r');
    plot(WinT,p,'g--');
    plot(T_skew,p,'k');   %plot them up
    plot(T_dry_skew,p,'b');
    if s==max(size(W))
        continue;
    else
        s=s+1;
    end
end


%plot up the sounding data
Tsonde_skew=Tsonde-(30.*log(0.001.*Psonde)); % skew the T
Tdsonde_skew=Tdsonde-(30.*log(0.001.*Psonde)); % skew the Td
plot(Tsonde_skew,Psonde,'k','linewidth',2)
plot(Tdsonde_skew,Psonde,'k--','linewidth',2)


%plot the convective parcel ascent
MLT = mean(Tsonde(21));
MLTd = mean(Tdsonde(21));
MLP = mean(Psonde(21));
[Tparcel,p3,~] = lift_parcel(MLT,MLTd,MLP,'parcel',W);
%[Tparcel,p,~] = lift_parcel(sfc_temp,sfc_tdz,sfc_pres,'parcel',W);
Tparcel_skew=Tparcel-(30.*log(0.001.*p3)); % skew the parcel T
plot(Tparcel_skew,p3,'b','linewidth',2)

%plot the dis parcel ascent
MLT = mean(Tsonde(14));
MLTd = mean(Tdsonde(14));
MLP = mean(Psonde(14));
[Tparcel1,p,pp,~] = DLift_parcel1(MLT,MLTd,MLP,'parcel',W);
Tparcel1(pp)
%[Tparcel,p,~] = lift_parcel(sfc_temp,sfc_tdz,sfc_pres,'parcel',W);
%Tparcel_skew2=Tparcel1-(30.*log(0.001.*p)); % skew the parcel T
[Tparcel_moist,p2,~] = DLift_parcel2(Tparcel1(pp),NaN,700-pp,'moist',W(s)); 
Tparcel_skew2_moist = Tparcel_moist - (30.*log(0.001.*p2));

%plot(Tparcel_skew2,p,'r','linewidth',2)
plot(Tparcel_skew2_moist,p2,'r','linewidth',2)

%plot up the wind barbs?
pbarb=100:25:1030;
if exist('wind_u','var')==1 & exist('wind_v','var')==1;
for i=1:max(size(pbarb))
    [f1 indbarb]=min(abs(Psonde-pbarb(i))); 
    %The minus on wind_v is to compensate for the reversed y axis
    plot_windbarb(-wind_u(indbarb),wind_v(indbarb),Psonde(indbarb),53,mpp,'ms');
end
end


%Calculate the CAPE
CAPE = 0;
for P=1:max(size(p3))-1
    [f1 indPsonde]=min(abs(Psonde-p3(P))); %for CAPE
    Tenv = Tsonde(indPsonde);
    Tpar = Tparcel(P);
    Tenv_K = Tenv +273.15;      
    Tpar_K = Tpar +273.15;
    R=287;
    AlphaEnv=R*Tenv_K/p3(P);
    AlphaPar=R*Tpar_K/p3(P);
    if (Tpar_K > Tenv_K) 
        C = (AlphaPar - AlphaEnv).*(p3(P)-p3(P+1));
        CAPE = CAPE + C;
    end
end

%Calculate the DCAPE

DCAPE = 0;
for P=1:max(size(p2))-1
    
    [f1 indPsonde2]=min(abs(Psonde-p2(P))); %for DCAPE
    Tenv = tz(indPsonde2);
    Tpar = Tparcel_moist(P);
    Tenv_K = Tenv +273.15;   
    Tpar_K = Tpar +273.15;
    R=287;
    AlphaEnv=R*Tenv_K/p2(P);
    
    AlphaPar=R*Tpar_K/p2(P);
    
    if (Tpar_K < Tenv_K) 
        C = (AlphaEnv - AlphaPar )*(p2(P)-p2(P+1));
        DCAPE = DCAPE + C;
    end
    
    
end

%Calculate the MWPI
%MWPI = (CAPE/1000)+(((tz(16)-tz(14))/(hz(16)-hz(14)))/5)+((tz(16)-tdz(16)-tz(14)+tdz(14))/5);
    
%transfer_time
transfer_time = datetime(tt/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_tt = datestr(transfer_time);
    
if strlength(transfer_tt) <20
    transfer_tt = [transfer_tt, ' 00:00:00'];
end
        
   title_name = ['Atmospheric Sounding of BARRA at ',transfer_tt];

%titles and labels
titlelin2=['  CAPE=',num2str(CAPE),'   DCAPE=',num2str(DCAPE),'    Surface temperature =',num2str(tz(21))];%' LI=',num2str(LI),' KI=',num2str(KI)];
title([ title_name '\rm' char(10) titlelin2]);    %%'\bf{SkewT-LogP Chart}'
xlabel('Temperature (C)')
ylabel('Pressure (hPa)')

