%A = readmatrix('wind2.csv');
clear
nb = 5;    % 2 3 8 35 37 42 
time_3 = 4;
lat_wind = readmatrix('lat_wind.csv');
lon_wind = readmatrix('lon_wind.csv');

TT = readmatrix('wind2.csv');
T_T = sortrows(TT,-6);

TTT = readcell('wind2.csv');
TTTT = TTT(2:end,:);
TTTTT = sortrows(TTTT,-6);

%%
%lat_position=find(lat_wind <= T(nb,3)+0.01 & lat_wind >= T(nb,3)-0.01);
%lon_position=find(lon_wind <= T(nb,4)+0.01 & lon_wind >= T(nb,4)-0.01);
%{1'Date/Time',2'Duration',3'Latitude',4'Longitude',5'Nearest town'}
%{6'Max Gust speed',7'Max Gust direction',8'Max Mean Wind speed'}
%{9'Max Mean Wind direction',10'Path length',11'Path width',12'Path direction'}
%{13'Fujita scale',14'Number of deaths',15'Number of injuries',16'Comments'}
%TTT.Data_Time.Format = 'MM/dd/uuuu HH:mm:ss';

lat_position = find(lat_wind >= T_T(nb,3)-min(abs(lat_wind-T_T(nb,3))) & lat_wind <= T_T(nb,3)+min(abs(lat_wind-T_T(nb,3))));
lon_position = find(lon_wind >= T_T(nb,4)-min(abs(lon_wind-T_T(nb,4))) & lon_wind <= T_T(nb,4)+min(abs(lon_wind-T_T(nb,4))));
["Error in latitude" min(abs(lat_wind-T_T(nb,3)))]
["Error in longitude" min(abs(lon_wind-T_T(nb,4)))]

T_time = TTTTT(nb,1);
T_time = [T_time{:}];
y = year(T_time);
m = month(T_time);
d = day(T_time);
h = hour(T_time)+1;
f = minute(T_time);
if h <= 23 
    if f >= 30
        h = h+1;
    end
else
        d = d+1;
        h = 0;
end

time_h = rem(h,6);
time_hh = (h-time_h)/6+1;
time_e = ["0000" "0600" "1200" "1800"];
h2 = time_e(time_hh);

y = num2str(y,'%04d');
m = num2str(m,'%02d');
d = num2str(d,'%02d');
h = num2str(h2,'%04d');
T = time_h;    

%% Reading the data directly
% the Hobart airport (lat -42.83 / lon 147.50) --> (lat,lon)--> (236,372)
year = y;   
month = m ;
day = d ; 
time = h ;     % '0000'; '0600'; '1200'; '1800';
variable = 'vertical_wnd';    %'vertical_wnd'; 'wnd_ucmp'; 'wnd_vcmp'; 'air_temp'; 'relhum'; 'pressure'; 'geop_ht'; 'time'; 
region ='BARRA_TA' ;    % 'BARRA_TA';     'BARRA_R';
station = 'prs' ;      
%lat_p =  236   ;         % 1-508 
%lon_p =  372   ;         % 1-594
lat_p =  lat_position ;         % 1-508
lon_p =  lon_position ;         % 1-594
T = time_h;                % 1-6
T = time_3;
%% e.g. vertical_wnd-fc-prs-PT1H-BARRA_TA-v1-20141229T0000Z.sub.nc

filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_wnd_ucmp = ['/Volumes/Backup_Plus/BARRA_TA/','wnd_ucmp/',year,'/',month,'/','wnd_ucmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_wnd_vcmp = ['/Volumes/Backup_Plus/BARRA_TA/','wnd_vcmp/',year,'/',month,'/','wnd_vcmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_air_temp = ['/Volumes/Backup_Plus/BARRA_TA/','air_temp/',year,'/',month,'/','air_temp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_relhum = ['/Volumes/Backup_Plus/BARRA_TA/','relhum/',year,'/',month,'/','relhum-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_geop_ht = ['/Volumes/Backup_Plus/BARRA_TA/','geop_ht/',year,'/',month,'/','geop_ht-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];

W_wind = ncread(filePath_vertical_wnd,'vertical_wnd'); 
%U_wind = ncread (filePath_wnd_ucmp,'wnd_ucmp');
%V_wind = ncread (filePath_wnd_vcmp,'wnd_vcmp');
%U = permute(U_wind,[2 1 3 4]);
%V = permute(V_wind,[2 1 3 4]);
W = permute(W_wind,[2 1 3 4]);

P_wind = ncread (filePath_vertical_wnd,'pressure');
%P_wind = ncread (filePath_relhum,'pressure');
lon_wind = ncread (filePath_vertical_wnd,'longitude');
lat_wind = ncread (filePath_vertical_wnd,'latitude');

%air_temp = ncread (filePath_air_temp,'air_temp');
%air_temp_1 = permute(air_temp,[2 1 3 4]);
%air_relhum = ncread (filePath_relhum,'relhum');
%air_relhum_1 = permute(air_relhum,[2 1 3 4]);
time_c= ncread(filePath_vertical_wnd,'time'); 
height = ncread('/Volumes/Backup_Plus/BARRA_TA/geop_ht/2014/01/geop_ht-fc-prs-PT1H-BARRA_TA-v1-20140101T0000Z.sub.nc','geop_ht');

[X1,Y1,Z1] = meshgrid(lon_wind,lat_wind,P_wind(:,1));
[x1,y1] = meshgrid(lon_wind,lat_wind(148));

filePath_uwnd10m = ['/Volumes/Backup_Plus/',region,'/','uwnd10m/',year,'/',month,'/','uwnd10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_vwnd10m = ['/Volumes/Backup_Plus/',region,'/','vwnd10m/',year,'/',month,'/','vwnd10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
U_uwnd10m = ncread (filePath_uwnd10m,'uwnd10m');
V_vwnd10m = ncread (filePath_vwnd10m,'vwnd10m');
U1 = permute(U_uwnd10m,[2 1 3]);
V1 = permute(V_vwnd10m,[2 1 3]);
%/Volumes/Backup_Plus/BARRA_TA/uwnd10m/2005/01/uwnd10m-fc-spec-PT1H-BARRA_TA-v1-20050101T0000Z.sub.nc
%% Vertical wind profile

y = squeeze(W(lat_p,lon_p,:,T));
x = squeeze(P_wind);
width = 2;
figure(1);
h = barh(x,y,width,'b');
set(gca,'YDir','reverse'); 
xlabel('Wind speed (m/s)');
ylabel('Pressure (hPa)');
xtips1 = h.YEndPoints + 0.3;
ytips1 = h.XEndPoints;
labels1 = string(h.YData);
%text(xtips1,ytips1,labels1,'VerticalAlignment','middle');

%% According to presures 

hpa = ["500hpa" "700hpa" "850hpa" "1000hPa"];
pre = [12 14 16 21];        % 21 16 14 12 .  27 29 32 37
j=4;
%% According to presures -- coastline 1

%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
%clat=[double(lat_wind(lat_p-4)) double(lat_wind(lat_p+4))];  clon=[double(lon_wind(lon_p-4)) double(lon_wind(lon_p+4))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

%range_ad = 100;  % 4
%range_lat = (lat_p-range_ad:5:lat_p+range_ad);
%range_lon = (lon_p-range_ad:5:lon_p+range_ad);
range_lat = (160:10:508);
range_lon = (1:10:540);

u_rf=zeros(1,594);
v_rf=zeros(1,594);
u_rf(1,410:418) = 30;
u_rf(1,290:298) = 20;
u_rf(1,190:198) = 10;

pres =pre (4);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);
figure(4);

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_contourf(lon(ilon),lat(ilat),Z',[-300:25:-25 2 50:50:200 300:100:1400 1450],'edgecolor','none');
%shading flat;

caxis([-300 1450]);   
colormap([m_colmap('blues',27);m_colmap('gland',128)]);

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on
%m_coast('line','color',[1 .85 .7],'LineWidth',2);
%hold on 
%qp = m_quiver(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),U(range_lat,range_lon,pres,T),V(range_lat,range_lon,pres,T),'k');
qp = m_quiver([x1(1,range_lon);X1(range_lat,range_lon,pres)],[y1(1,range_lon);Y1(range_lat,range_lon,pres)],[u_rf(1,range_lon);U1(range_lat,range_lon,T)],[v_rf(1,range_lon);V1(range_lat,range_lon,T)],'k');
%Finally some text is included:
set(qp,'LineWidth',0.9,'MaxHeadSize',.1,'Color','black')
%set(qp,'LineWidth',2,'MaxHeadSize',.1,'AutoScaleFactor',1,'Color','black')
m_text(145.3,-44,'Arrow scale: 10m/s')
m_text(146.8,-44,'Arrow scale: 20m/s')
m_text(148.4,-44,'Arrow scale: 30m/s')

hold on
ax = m_contfbar( .95,[.3 .7], Z',[-300:25:-25 2 50:50:200 300:100:1400 1450],...
           'axfrac',.02,'endpiece','no','levels','match');  %ax=m_contfbar([.3 .7],.05,CS,CH);
ax.YLabel.String='Wind speeds m/s';
       set(ax,'fontsize',10)
hold on

%[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'color','k');
%clabel(cs,h,'LineWidth',1.5,'fontsize',8);

transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Wind 10m above the ground at',' at Hobart ',transfer_time_1 ,'\rm', char(10)];
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;
%colormap(flipud(m_colmap('Blue',256)))

%set(m_bar, 'Position', [.3 .01 .4150 .005]);


%% According to presures -- coastline 2

range_ad = 40;  % 50 40
%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
%clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
clat=[double(lat_wind(lat_p-range_ad)) double(lat_wind(lat_p+range_ad))];  
clon=[double(lon_wind(lon_p-range_ad)) double(lon_wind(lon_p+range_ad))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];


range_lat = (lat_p-range_ad+10:3:lat_p+range_ad);
range_lon = (lon_p-range_ad:3:lon_p+range_ad);  % 4 3
%range_lat = (160:8:508);
%range_lon = (1:8:540);

[x1,y1] = meshgrid(lon_wind,lat_wind(180));  % Hobart  195  Brighton 210  Queenstown 254 White beach 180 
u_rf=zeros(1,594);
v_rf=zeros(1,594);
%u_rf(1,360:364) = 30;
%u_rf(1,280:284) = 15;

%u_rf(1,331) = 15;
%u_rf(1,364) = 30;

%u_rf(1,322) = 15;
%u_rf(1,358) = 30;

%u_rf(1,193) = 15;
%u_rf(1,229) = 30;

u_rf(1,355) = 15;
u_rf(1,391) = 20;

pres =pre (4);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);
figure(11);

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_contourf(lon(ilon),lat(ilat),Z',[-300:25:-25 2 50:50:200 300:100:1400 1450],'edgecolor','none');
%shading flat;

caxis([-300 1450]);   
colormap([m_colmap('blues',27);m_colmap('gland',128)]);

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on
%m_coast('line','color',[1 .85 .7],'LineWidth',2);
%hold on 
%qp = m_quiver(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),U(range_lat,range_lon,pres,T),V(range_lat,range_lon,pres,T),'k');
qp = m_quiver([x1(1,range_lon);X1(range_lat,range_lon,pres)],[y1(1,range_lon);Y1(range_lat,range_lon,pres)],[u_rf(1,range_lon);U1(range_lat,range_lon,T)],[v_rf(1,range_lon);V1(range_lat,range_lon,T)],'k');
%Finally some text is included:
set(qp,'LineWidth',0.9,'MaxHeadSize',.1,'Color','black')
%set(qp,'LineWidth',2,'MaxHeadSize',.1,'AutoScaleFactor',1,'Color','black')

%m_text(146.4,-44,'Arrow scale: 15m/s')
%m_text(147.5,-44,'Arrow scale: 30m/s')

%m_text(147.0,-43.38,'Arrow scale: 15m/s')
%m_text(147.5,-43.38,'Arrow scale: 30m/s')

%m_text(146.9,-43.18,'Arrow scale: 15m/s')
%m_text(147.4,-43.18,'Arrow scale: 30m/s')

%m_text(145.15,-42.58,'Arrow scale: 15m/s')
%m_text(145.65,-42.58,'Arrow scale: 30m/s')

m_text(147.35,-43.58,'Arrow scale: 15m/s')
m_text(147.85,-43.58,'Arrow scale: 30m/s')


hold on
ax = m_contfbar( .95,[.3 .7], Z',[-300:25:-25 2 50:50:200 300:100:1400 1450],...
           'axfrac',.02,'endpiece','no','levels','match');  %ax=m_contfbar([.3 .7],.05,CS,CH);
ax.YLabel.String='Topographic height m';
       set(ax,'fontsize',10)
hold on

%[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'color','k');
%clabel(cs,h,'LineWidth',1.5,'fontsize',8);

transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
%title_name = ['Wind 10m above the ground ',' at Hobart ',transfer_time_1 ,'\rm', char(10)];
title_name = ['Wind 10m above the ground',' at White beach ',' 26-Jan-2005 07:00:00','\rm', char(10)];
%Hobart  148 Brighton White beach 195 Queenstown 
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;
%colormap(flipud(m_colmap('Blue',256)))

%set(m_bar, 'Position', [.3 .01 .4150 .005]);

%%

%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
%clat=[double(lat_wind(lat_p-4)) double(lat_wind(lat_p+4))];  clon=[double(lon_wind(lon_p-4)) double(lon_wind(lon_p+4))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

%range_ad = 100;  % 4
%range_lat = (lat_p-range_ad:5:lat_p+range_ad);
%range_lon = (lon_p-range_ad:5:lon_p+range_ad);
range_lat = (20:490);
range_lon = (20:574);

figure(5);
for ee = 1:4
    
pres =pre (ee);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);

subplot(1,4,ee)

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on

m_contourf(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_relhum_1(range_lat,range_lon,pres,T),'edgecolor','k');
colormap(m_colmap('blues',50));
hold on

m_coast('line','color',[1 .85 .7],'LineWidth',2);

hold on 
%m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'LineWidth',2,'ShowText','on');
%[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T));
%clabel(cs,h,'LineWidth',1.3,'fontsize',8);
  
transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Relative humidity at ',convertStringsToChars(hpa(ee)),' at Tasmaina ',transfer_time_1 ,'\rm', char(10)];
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;

colormap(flipud(m_colmap('Blue',256)))
end


%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
%clat=[double(lat_wind(lat_p-4)) double(lat_wind(lat_p+4))];  clon=[double(lon_wind(lon_p-4)) double(lon_wind(lon_p+4))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

%range_ad = 100;  % 4
%range_lat = (lat_p-range_ad:5:lat_p+range_ad);
%range_lon = (lon_p-range_ad:5:lon_p+range_ad);
range_lat = (20:490);
range_lon = (20:574);

figure(6);
    
pres =pre (4);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);


m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on

m_contourf(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_relhum_1(range_lat,range_lon,pres,T),'edgecolor','k');
colormap(m_colmap('blues',50));
hold on

m_coast('line','color',[1 .85 .7],'LineWidth',2);

hold on 
%m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'LineWidth',2,'ShowText','on');
%[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T));
%clabel(cs,h,'LineWidth',1.3,'fontsize',8);
  
transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Relative humidity at ',convertStringsToChars(hpa(j)),' at Tasmaina ',transfer_time_1 ,'\rm', char(10)];
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;

colormap(flipud(m_colmap('Blue',256)))

%%

%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
%clat=[double(lat_wind(lat_p-4)) double(lat_wind(lat_p+4))];  clon=[double(lon_wind(lon_p-4)) double(lon_wind(lon_p+4))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

%range_ad = 100;  % 4
%range_lat = (lat_p-range_ad:5:lat_p+range_ad);
%range_lon = (lon_p-range_ad:5:lon_p+range_ad);
range_lat = (20:490);
range_lon = (20:574);

figure(7);
for ee = 1:4
    
pres =pre (ee);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);

subplot(1,4,ee)

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on

m_coast('line','color',[1 .85 .7],'LineWidth',2);

hold on 
%m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'LineWidth',2,'ShowText','on');
[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T));
clabel(cs,h,'LineWidth',1.3,'fontsize',8);
  
transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Air temperature ',convertStringsToChars(hpa(ee)),' at Tasmaina ',transfer_time_1 ,'\rm', char(10)];
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;
colormap
end


%%

%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
%clat=[double(lat_wind(lat_p-4)) double(lat_wind(lat_p+4))];  clon=[double(lon_wind(lon_p-4)) double(lon_wind(lon_p+4))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

%range_ad = 100;  % 4
%range_lat = (lat_p-range_ad:5:lat_p+range_ad);
%range_lon = (lon_p-range_ad:5:lon_p+range_ad);
range_lat = (20:490);
range_lon = (20:574);

figure(8);
    
pres =pre (4);

lon = ncread (filePath_vertical_wnd,'longitude');
lat = ncread (filePath_vertical_wnd,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on

m_coast('line','color',[1 .85 .7],'LineWidth',2);

hold on 
%m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'LineWidth',2,'ShowText','on');
[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T));
clabel(cs,h,'LineWidth',1.3,'fontsize',8);
  
transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Air temperature at ',convertStringsToChars(hpa(j)),' at Tasmaina ',transfer_time_1 ,'\rm', char(10)];
%text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;
colormap
